<?php
/*
  Plugin Name: Generate Slugs
  Plugin URI: http://www.jerrytravis.com/598/wordpress-plugin-to-generate-post-slugs
  Description: A simple plugin to regnerate slugs from post titles. Once you activate the plugin, you can get to the admin screen for it by going to the <strong>Generate Slugs</strong> link under the <strong>Tools</strong> menu on the admin page.
  Version: 0.1
  Author: Jerry Travis Smith
  Author URI: http://www.jerrytravis.com
  License: GPLv2 - http://www.gnu.org/licenses/gpl-2.0.txt

 */
register_activation_hook(__FILE__, 'jt_regen_slug_install');
register_deactivation_hook(__FILE__, 'jt_regen_slug_uninstall');
add_action('admin_menu', 'jt_regen_create_settings_page');

function jt_regen_slug_install() {
  
}

function jt_regen_slug_uninstall() {
  
}

function jt_regen_create_settings_page() {
  add_management_page('Generate Slugs', 'Generate Slugs', 'manage_options', __FILE__, 'jt_regen_admin_page');
}

function jt_regen_admin_page() {
  if (!current_user_can('manage_options')) {
    wp_die('Insufficient permissions!');
  } else {
    ?>
    <div class="wrap">
      <h1>Generate Slugs Plugin</h1>
      <p>This simple plugin will generate slugs for posts that do not already have a slug value (i.e. the post_name field in the wp_posts table). This may be a problem if you import
        posts from an existing blogging system into Wordpress and the slugs aren't generated. Simply click the 
        <em>"Generate Post Slugs"</em> below and any posts that do not have a slug will have one generated using the 
        post title. The plugin has been tested with Wordpress 3.2.1, but it should work with any version of Wordpress 2+. </p>
      <h2>License</h2>
      <p>By using this plugin, you acknowledge that this plugin (and all its source code) is distributed <strong style="color:#990000">AS IS</strong> with no implicit or explicit warranty as to the plugin's fitness for any specific purpose, 
        and is released under the <a href="http://www.gnu.org/licenses/gpl-2.0.txt">GPLv2</a> license. It is strongly recommended that you make a backup of your Wordpress installation before using this plugin.</p>
      <p>If you agree to the licensing terms above, click the Generate Post Slugs button now to generate the post slugs. 
      <form action="<?php echo str_replace('%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post"> 
        <input name="regen-clicked" type="hidden" value="1" />
        <input type="submit" value="Generate Post Slugs" />
      </form>
    </p>
    </div>
    <?php
    if (isset($_POST['regen-clicked'])) {
      $query = new WP_Query('posts_per_page=-1');
      $update_count = 0;
      foreach ($query->posts as $post) {
        //echo $post->post_name . '<br />';
        if ($post->post_name == "") {
          $post_to_update = array();
          $post_to_update['ID'] = $post->ID;
          $post_to_update['post_name'] = sanitize_title($post->post_title);
          wp_update_post($post_to_update);
          $update_count+=1;
        }
      }
      echo '</p><strong>Post slugs successfully generated for ' . $update_count . ' posts</p></strong>';
    }
  }
}
?>